package com.fp.persistence.pgeneral.gene;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEACCOUNTRELATIONSHIP*/
@Embeddable
public class TgeneAccountRelationshipKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="ACCOUNT", nullable=false,updatable=false)

/**
* Numero de cuenta
*/
private String account;

@Column(name="PERSONCODE", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer personcode;

@Column(name="COMPANY", nullable=false,updatable=false)

/**
* Codigo de compania a la que pertence la cuenta
*/
private Integer company;

/**Contructor por defecto*/
public TgeneAccountRelationshipKey(){}
/**Contructor de TgeneAccountRelationshipKey
@param pAccount Numero de cuenta
@param pPersoncode Codigo de persona
@param pCompany Codigo de compania a la que pertence la cuenta
*/
public TgeneAccountRelationshipKey(String pAccount,Integer pPersoncode,Integer pCompany){
 account=pAccount;
 personcode=pPersoncode;
 company=pCompany;
}
/**Obtiene el valor de account
@return valor de account*/
public String getAccount(){
  return account;
}
/**Fija el valor de account
@param pAccount nuevo Valor de account*/
public void setAccount(String pAccount){
  account=pAccount;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de company
@return valor de company*/
public Integer getCompany(){
  return company;
}
/**Fija el valor de company
@param pCompany nuevo Valor de company*/
public void setCompany(Integer pCompany){
  company=pCompany;
}

/**Implementación de la comparación de TgeneAccountRelationshipKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneAccountRelationshipKey))return false;
  TgeneAccountRelationshipKey that = (TgeneAccountRelationshipKey) o;
  if (this.getAccount() == null || that.getAccount() == null){
      return false;
  }
  if (! this.getAccount().equals(that.getAccount())){
    return false;
  }
  if (this.getPersoncode() == null || that.getPersoncode() == null){
      return false;
  }
  if (! this.getPersoncode().equals(that.getPersoncode())){
    return false;
  }
  if (this.getCompany() == null || that.getCompany() == null){
      return false;
  }
  if (! this.getCompany().equals(that.getCompany())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneAccountRelationshipKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getAccount() == null ? 0 : this.getAccount().hashCode());
    result = result * 37 + (this.getPersoncode() == null ? 0 : this.getPersoncode().hashCode());
    result = result * 37 + (this.getCompany() == null ? 0 : this.getCompany().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
